
package equation2nddegre;
                                                                     
/** Equation du second degr version objet, deuxime version
 * le calcul des racines est mmoris
 */
public class EquationObj1 {
  private double a, b, c;
  private double racine1 = Double.NaN;  // NaN === NaN ne marche pas
  private double racine2 = Double.NaN;  // mais Double.isNaN(Double.NaN) marche

  /** cre une quation (instance de EquationObj1)
   * @param a, b, c les coefficients de cette equation
   */
   public EquationObj1(double a, double b, double c) {
     this.a = a;
     this.b = b;
     this.c = c;
     }

  /** rsout cette quation et mmorise les racines */
  public void resolution() {
     this.racine1 = (-this.b + Math.sqrt(this.delta()))/(2*this.a);
     this.racine2 = (-this.b - Math.sqrt(this.delta()))/(2*this.a);
     }

   /** renvoie le discriminant de cette quation */
  private double delta() {return this.b * this.b - 4 * this.a * this.c;}

  /** renvoie  une racine de cette quation */
  public double getRacine1() { return(this.racine1); }
 
  /** renvoie l'autre racine de cette quation */
  public double getRacine2() { return(this.racine2); }

  /** renvoie une reprsentation sous forme de chaine de cette quation
   * et de ses racines si elles ont t calcules
   */
  public String toString() {
     String chaine = "\nquation (version objet avec attributs racines) "+
                     this.a+" x^2 + "+this.b+" x + "+this.c+" = 0";
     if (Double.isNaN(this.racine1))
             chaine = chaine + "\n il n'y a pas (ou pas encore) de racines";
     else chaine += "\nracines "+ this.racine1+ " et "+this.racine2;
     return(chaine);
    }

}
