package comptes;
import java.util.Vector;

/** Modlisation simple d'un compte bancaire. */
public class Compte0 {

 // attributs d'instance
 private String titulaire;
 protected /*private*/ int numero;     // protected pour sous-classes
 private double solde;
 protected /* private */ Vector releve; // protected pour sous-classes
 // attribut de classe
 private static int nbComptes=0; 

 // constructeurs
 /** Cre un compte pour le titulaire spcifi. */
 public Compte0(String nomTitulaire) {
   Compte0.nbComptes++; // ou this.nbComptes++; // ou nbComptes++;
   this.numero = nbComptes;
   this.titulaire = nomTitulaire;
   this.releve = new Vector();
   }
 /** Cre un compte pour le titulaire spcifi 
  *          avec le versement inital spcifi. */
 public Compte0(String nomTitulaire, double versementInitial) {
   this(nomTitulaire);
   this.crediter(versementInitial);
   }

 /** Crdite ce compte du montant spcifi. */
 public void crediter(double montant) {
   if (montant > 0) this.enregistrer(montant);
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - crdit non effectu");}
 /** Enregistre pour ce compte le montant (sign) spcifi. */
 public void enregistrer(double montant) {
   this.solde += montant;
   this.releve.addElement(new Double(montant));
   // ou this.releve.addElement(""+montant);
   }
 /** Dbite, si possible, ce compte du montant spcifi. */
 public void debiter(double montant) {
   if (montant > 0)
     if (this.isDebitPossible(montant))this.enregistrer(-montant);
     else System.out.println("dbit non autoris, solde insuffisant");
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - dbit non effectu");}
 /** Teste si le dbit spcifi est possible pour ce compte. */
 public boolean isDebitPossible(double montant) {
                           return montant < this.solde;}
 /** Vire, si possible, le montant spcifi de ce compte 
  *                              vers le compte spcifi. */
 public void virer(double montant, Compte0 c) {
   if (montant >0)
      if (isDebitPossible(montant)) {
         this.debiter(montant);
         c.crediter(montant);
         }
      else System.out.println("dbit non autoris");
   else System.out.println(
         "erreur : vous avez donn un montant ngatif - virement non effectu");
   }

 /** Renvoie le numro de ce compte. */
 public int getNumero() {return this.numero;}
 /**  Renvoie le titulaire de ce compte. */
 public String getTitulaire() {return this.titulaire;}
 /**  Renvoie le solde de ce compte. */
 public double getSolde() {return this.solde;}
 /**  Renvoie le relev de ce compte. */
 public String getReleve() {
     return this.toString()+ "relev : "+this.releve.toString();}

 /** Renvoie le RIB de ce compte. */
 public String RIB() {
   return "compte numro : "+ this.numero + "\ntitulaire : " + this.titulaire;}
 /** Renvoie une reprsentation sous forme de chaine de ce compte */
 public String toString() {
   String s = "\n==================\n"
            + this.RIB() + "\nsolde : " + this.solde;
   s+="\n==================\n";
   return s;
   }

}
