package comptes;
import java.util.Vector;
import java.util.Date;
import java.text.DecimalFormat;

/** Modlisation d'un compte bancaire. */
public class CompteEnBanque {
 // constantes
 private static double decouvertAutoriseParDefaut =100;
 public static final int ESPECES = 0;
 public static final int CHEQUE = 1;
 public static final int CB = 2;
 public static final int VIREMENT = 3;
 private static final String[] lesMoyensPaiement =
                              {"espces ", "chque  ", "CB      ", "virement"};
 protected static final DecimalFormat df = new DecimalFormat("###0.00");
 // attributs d'instance
 private Banque banque;
 private String titulaire;
 private int numero;
 private double solde;
 private Vector releve;
 private double decouvertAutorise;
 // attributs de classe
 private static int nbComptes=0;
 // constructeurs
 public CompteEnBanque(Banque banque, String nomTitulaire, double versementInitial, int moyenPaiement,
               double decouvertAutorise) {
   this(banque, nomTitulaire);
   this.crediter(versementInitial, moyenPaiement);
   this.decouvertAutorise = decouvertAutorise;
                         // ou setDecouvertAutorise(decouvertAutorise);
   }
 public CompteEnBanque(Banque banque, String nomTitulaire,double versementInitial,int moyenPaiement) {
   this(banque, nomTitulaire, versementInitial, moyenPaiement,
                                     CompteEnBanque.decouvertAutoriseParDefaut);
   // ou this(nomTitulaire, versementInitial, moyenPaiement,
   //                                              decouvertAutoriseParDefaut);
   }
 public CompteEnBanque(Banque banque, String nomTitulaire) {
   this.banque=banque;
   // this.nbComptes++;
   // this.numero = nbComptes;
   this.numero = banque.nouveauNumeroCompte(this);
   this.titulaire = nomTitulaire;
   this.releve = new Vector(); // Attention :  crer avant de crditer
   this.decouvertAutorise = decouvertAutorise;
                                 // ou setdecouvertautorise(decouvertAutorise);
   }
 public void crediter(double montant, int moyenPaiement) {
   if (montant > 0) this.enregistrer(montant, moyenPaiement);
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - crdit non effectu");}
 public void enregistrer(double montant, int moyenPaiement) {
   this.solde += montant;
   String date = new Date().toString();
   date = date.substring(4,16)+date.substring(23,28);
   this.releve.addElement(date+" "+lesMoyensPaiement[moyenPaiement]+
       ((montant >0)?" crdit +":" dbit  ")+CompteEnBanque.df.format(montant));
   }
 public void debiter(double montant, int moyenPaiement) {
   if (montant > 0)
     if (this.isDebitPossible(montant))this.enregistrer(-montant,moyenPaiement);
     else System.out.println("dbit non autoris, solde insuffisant");
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - dbit non effectu");}
 public boolean isDebitPossible(double montant) {
                           return montant < this.solde+this.decouvertAutorise;}
 public void virer(double montant, CompteEnBanque c) {
   if (montant >0)
      if (isDebitPossible(montant)) {
         this.debiter(montant, CompteEnBanque.VIREMENT);
         c.crediter(montant, CompteEnBanque.VIREMENT);
         }
      else System.out.println("dbit non autoris");
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - virement non effectu");
   }
 public int getNumero() {return this.numero;}
 public String getTitulaire() {return this.titulaire;}
 public double getSolde() {return this.solde;}
 public String getReleve() {
  StringBuffer sb = new StringBuffer(this.toString()+"relev : \n");
  for (int i=0; i<this.releve.size();i++)
            sb.append(this.releve.elementAt(i)+"\n");
    return sb.toString();
  }
 public double getDecouvertAutorise() {return this.decouvertAutorise;}
 public void setDecouvertAutorise(double decouvertAutorise) {
   if (decouvertAutorise >0) this.decouvertAutorise = decouvertAutorise;}
 public static double getDecouvertAutoriseParDefaut() {
                                   return CompteEnBanque.decouvertAutoriseParDefaut;}
 public static void setDecouvertAutoriseParDefaut(double decouvertAutoriseParDefaut) {
   if (decouvertAutoriseParDefaut >0)
                 CompteEnBanque.decouvertAutoriseParDefaut = decouvertAutoriseParDefaut;}
 public String RIB() {
   return "banque "+this.banque.getNom()+"\ncompte numro : "+ this.banque.getCode()+"_"+this.numero + "\ntitulaire : " + this.titulaire;}
 public String toString() {
   String s = "\n==================\n"
            + this.RIB() + "\nsolde : " + CompteEnBanque.df.format(this.solde)
            + "\ndcouvert autoris : " + CompteEnBanque.df.format(this.decouvertAutorise);
   if (this.solde < 0) s += "\nvous tes en dcouvert";
   s+="\n==================\n";
   return s;
   }



}


