package comptes;

public class TestCompte {
  /** Teste la classe Compte. */
  public static void main(String[] args) {
    System.out.println("TestCompte "+new java.util.Date());
    System.out.println("\nDcouvert autoris par dfaut "
                    +Compte.df.format(Compte.getDecouvertAutoriseParDefaut()));
    Compte c1 = new Compte("Dupond", 200, Compte.ESPECES);
    Compte c2 = new Compte("Durand", 100, Compte.CHEQUE, 500);
    System.out.println(c1+""+c2);

    c1.crediter(100.15, Compte.CHEQUE);
    System.out.println("solde de "+c1.getTitulaire()+" : "+c1.getSolde()+"\n");
    c1.crediter(-300, Compte.CHEQUE);
    System.out.println("solde de "+c1.getTitulaire()+" : "+c1.getSolde()+"\n");
    c1.crediter(300, Compte.CHEQUE);
    System.out.println("solde de "+c1.getTitulaire()+" : "+c1.getSolde()+"\n");
    c1.debiter(1500, Compte.CB);
    System.out.println("solde de "+c1.getTitulaire()+" : "+c1.getSolde()+"\n");
    c1.debiter(130, Compte.CB);
    System.out.println("solde de "+c1.getTitulaire()+" : "+c1.getSolde()+"\n");
    c1.virer(200.50,c2);
    System.out.println("solde de "+c1.getTitulaire()+" : "+c1.getSolde()+"\n");
    c2.virer(500,c1);
    System.out.println("solde de "+c2.getTitulaire()+" : "+c2.getSolde()+"\n");
    System.out.println(c1.getReleve()+"\n"+c2.getReleve());


    c1.debiter(1000, Compte.ESPECES);
    System.out.println("Modification du dcouvert autoris");
    c1.setDecouvertAutorise(300);
    c1.debiter(1000, Compte.ESPECES);
    System.out.println(c1);

    System.out.println("Dcouvert autoris par dfaut "
                                      +Compte.getDecouvertAutoriseParDefaut());
    System.out.println("Modification du dcouvert autoris par dfaut");
    Compte.setDecouvertAutoriseParDefaut(600);
    System.out.println("Dcouvert autoris par dfaut "
                                      +Compte.getDecouvertAutoriseParDefaut());
    Compte c3 = new Compte("Martin");
    System.out.println(c1+""+c2+""+c3);

    }
}

/*

TestCompte Mon Jan 12 14:52:44 CET 2004

Dcouvert autoris par dfaut 100,00

==================
compte numro : 1
titulaire : Dupond
solde : 200,00
dcouvert autoris : 100,00
==================

==================
compte numro : 2
titulaire : Durand
solde : 100,00
dcouvert autoris : 100,00
==================

solde de Dupond : 300.15

erreur : vous avez donn un montant ngatif - crdit non effectu
solde de Dupond : 300.15

solde de Dupond : 600.15

dbit non autoris, solde insuffisant
solde de Dupond : 600.15

solde de Dupond : 470.15

solde de Dupond : 269.65

dbit non autoris
solde de Durand : 300.5


==================
compte numro : 1
titulaire : Dupond
solde : 269,65
dcouvert autoris : 100,00
==================
relev : 
Jan 12 14:52 2004 espces  crdit +200,00
Jan 12 14:52 2004 chque   crdit +100,15
Jan 12 14:52 2004 chque   crdit +300,00
Jan 12 14:52 2004 CB       dbit  -130,00
Jan 12 14:52 2004 virement dbit  -200,50


==================
compte numro : 2
titulaire : Durand
solde : 300,50
dcouvert autoris : 100,00
==================
relev : 
Jan 12 14:52 2004 chque   crdit +100,00
Jan 12 14:52 2004 virement crdit +200,50

dbit non autoris, solde insuffisant
Modification du dcouvert autoris
dbit non autoris, solde insuffisant

==================
compte numro : 1
titulaire : Dupond
solde : 269,65
dcouvert autoris : 300,00
==================

Dcouvert autoris par dfaut 100.0
Modification du dcouvert autoris par dfaut
Dcouvert autoris par dfaut 600.0

==================
compte numro : 1
titulaire : Dupond
solde : 269,65
dcouvert autoris : 300,00
==================

==================
compte numro : 2
titulaire : Durand
solde : 300,50
dcouvert autoris : 100,00
==================

==================
compte numro : 3
titulaire : Martin
solde : 0,00
dcouvert autoris : 600,00
==================


*/

