package enumerations;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

/** Tests d'numrations (vecteurs, Hashtable, cls, tableaux). */
public class Tests {
  public static void main(String[] args) {
    Vector v = new Vector();
    v.addElement("abc");
    v.addElement(new Integer(65));
    v.addElement(new Double(54));
    System.out.println("\nnumration du vecteur");
    for (Enumeration e = v.elements();e.hasMoreElements();)
      System.out.print(e.nextElement()+" ");

    Hashtable h = new Hashtable();
    h.put("DP","Dominique Pastre");
    h.put("BB","Bruno Bouzy");
    h.put("YP","Yannick Parchemal");
    System.out.println("\n\n\nnumration de la Hashtable");
    for (Enumeration e = h.elements();e.hasMoreElements();)
      System.out.print(e.nextElement()+" ");
    System.out.println("\n\nnumration des cls de la Hashtable");
    for (Enumeration e = h.keys();e.hasMoreElements();)
      System.out.print(e.nextElement()+" ");
    System.out.println("\n\nnumration des lments rangs dans la Hashtable");
    for (Enumeration e = h.keys();e.hasMoreElements();)
      System.out.print(h.get(e.nextElement())+" ");
    Object s="Yannick Parchemal";
    System.out.println("\n\ntrouver la cl de "+s);
    boolean trouve =false;
    for (Enumeration e = h.keys();e.hasMoreElements() && ! trouve;) {
      Object cle = e.nextElement();
      if (h.get(cle).equals(s)) {
         trouve = true;
         System.out.println("la cle de "+s+" est "+cle);
         }
      }
    
    int [] tab = {5,9,8,6,7};
    System.out.println("\n\nnumration du tableau tab");
    for (Enumeration e= new TabEnumeration(tab);e.hasMoreElements();)
      System.out.print(e.nextElement()+" ");

    int [][] tab2 = {{1,2,3,4,5},{10,11},{100,101,102}};
    System.out.println("\n\nnumration du tableau tab2");
    for (Enumeration e= new Tab2Enumeration(tab2);e.hasMoreElements();)
      System.out.print(e.nextElement()+" ");
    
    int [][] tab2bis = {{13,19,87,98},{23,95,54,52},{55,67,34,75}};
  System.out.println("\n\nnumration du tableau tab2 avec passage  la ligne");
    for (Enumeration e= new Tab2bisEnumeration(tab2bis);e.hasMoreElements();)
      System.out.print(" "+e.nextElement());
    }
}

/*

numration du vecteur
abc 65 54.0 


numration de la Hashtable
Dominique Pastre Yannick Parchemal Bruno Bouzy 

numration des cls de la Hashtable
DP YP BB 

numration des lments rangs dans la Hashtable
Dominique Pastre Yannick Parchemal Bruno Bouzy 

trouver la cl de Yannick Parchemal
la cle de Yannick Parchemal est YP


numration du tableau tab
5 9 8 6 7 

numration du tableau tab2
1 2 3 4 5 10 11 100 101 102 

numration du tableau tab2 avec passage  la ligne
 13 19 87 98
 23 95 54 52
 55 67 34 75

*/

