
package rationnels;
import java.util.Date;
import java.io.*;

public class Rationnel implements Serializable {

private int num,den;
private Date d;

/** cre un rationnel connaissant le numrateur et le dnominateu  non nul
 * @param n  le numrateur
 * @param d   le dnominateur */
 public Rationnel(int n,int d){
  if (d==0) throw new ArithmeticException("le dnominateur ne peut tre nul");
  this.num=n;this.den=d;this.simplifier();
  }

/** renvoie une chane de caractres reprsentant ce rationnel avec la
  * notation habituelle sous forme de fractions irrductibles
  * @return cette chaine */
 public String toString(){
  if ((this.den==1)||(this.num==0)) return(""+this.num);
  else return(""+this.num+'/'+this.den);
 }

 /*
 private static int pgcd(int a,int b){
  while (a!=b)  if (a>b){a=a-b;}else {b=b-a;};
  return(a);
 }
 */

/* renvoie le pgcd de deux entiers */
  private static int pgcd(int a,int b) {
  int r = a;
  while (r!=0)  {r = a%b; a=b; b=r; }
  return(a);
 }

/* normalise ce rationnel en le mettant sous forme
 * irrductible avec un dnominateur positif */
 private void simplifier(){
   if (this.num==0) this.den=1;
   else { int p = Rationnel.pgcd(this.num,this.den);this.num /= p;this.den /= p;
                                 // ou this.num=this.num/p;this.den =this.den/p;
          if (this.den < 0) {this.num= -this.num; this.den=- this.den;}
        };
  }

/** renvoie la somme de deux rationnels
 * @param a et b les deux rationnels
 * @return la somme */
 public static Rationnel somme(Rationnel a,Rationnel b){
  return(new Rationnel(a.num*b.den+a.den*b.num,a.den*b.den));
 }

/** ajoute un rationnel  ce rationnel
 * @param a le rationnel ajout
 * @return la somme */
 public Rationnel somme(Rationnel a){
  return(new Rationnel(a.num*this.den+a.den*this.num,a.den*this.den));
 }

/** renvoie le produit de deux rationnels
 * @param a et b les deux rationnels
 * @return le produit */
 public static Rationnel produit(Rationnel a,Rationnel b){
  return(new Rationnel(a.num*b.num,a.den*b.den));
 }

/** multiplie ce rationnel par un rationnel
 * @param a le rationnel par lequel on multiplie
 * @return le produit */
 public Rationnel produit(Rationnel a){
  return(new Rationnel(a.num*this.num,a.den*this.den));
 }

/** renvoie l'inverse d'un rationnel
 * @param a le rationnel
 * @return l'inverse */
 public static Rationnel inverse(Rationnel a){
  return new Rationnel(a.den,a.num);
  }

/** renvoie l'inverse de ce rationnel
 * @return l'inverse */
 public Rationnel inverse(){
  return new Rationnel(this.den,this.num);
  }


};

