
package fenetres;
import java.awt.Frame;
import java.awt.Button;
import java.awt.Label;
import java.awt.TextField;
import java.awt.TextArea;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout; 
import java.awt.GridLayout; 
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

/** 3me version du programme Bonjour.
 *  Meilleur agencement et zone de texte.
 *  Meilleurs gestion des exceptions et affichage des messages d'erreur. */
public class Fenetre3 extends Frame implements ActionListener {
  // identite
  private TextField tfNom =new TextField(10); 
  public TextField tfPrenom =new TextField(10);
  // naissance
  private TextField tfAnnee =new TextField(10);
  // notes
  private double note1, note2;
  private TextField tfNote1, tfNote2; 
  // boutons
  private Button bValider = new Button("valider");
  private Button bQuitter = new Button("quitter");
  // messages
  private TextArea ta = new TextArea(6,10); // zone de texte

  public Fenetre3(String titre) {
    super(titre);
    this.setLayout(new BorderLayout()); // N S Centre O E
    // questions (1er Panel au nord)
    Panel questions= new Panel(new GridLayout(3,1)); // 3 composants en colonne 
    this.add("North", questions);
       // identite
       Panel identite = new Panel(new FlowLayout()); questions.add(identite);
       identite.add(new Label("nom"));identite.add(tfNom);
       identite.add(new Label("prenom"));identite.add(tfPrenom);
       // naissance
       Panel naissance= new Panel(new FlowLayout()); questions.add(naissance);
       naissance.add(new Label("anne de naissance")); naissance.add(tfAnnee);
       // notes
       Panel pNotes = new Panel(new FlowLayout()); questions.add(pNotes);
       pNotes.add(new Label("notes"));
       tfNote1=new TextField(5); tfNote2=new TextField(5);
       pNotes.add(tfNote1);pNotes.add(tfNote2);
    // boutons (2me Panel au centre)
    Panel boutons = new Panel(new FlowLayout()); this.add("Center",boutons);
    boutons.add(bValider); boutons.add(bQuitter);
    // zone de texte (3me composant au sud);
    this.add("South",ta);

    bValider.addActionListener(this);
    bQuitter.addActionListener(this);
    this.addWindowListener(new GestionnaireExit());
    }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource()== bQuitter) System.exit(0);
    String message= "";
    DecimalFormat df = new DecimalFormat("0.##");// identite
    String nom = tfNom.getText();
    String prenom = tfPrenom.getText();
    message += "bonjour "+prenom+" "+nom;
    if (nom.equals("")) message +="\n(nom absent)";
    // naissance
    try {
    String annee = tfAnnee.getText();
    if (annee.equals("")) throw new Exception("\nanne de naissance absente");
    int age = 2004 - Integer.parseInt(annee);
    message += "\nvous avez "+age+" ans";
     } catch(NumberFormatException ex){message += 
                            "\nanne de naissance incorrecte";}
       catch(Exception ex) {message += ex.getMessage();}
    // notes
    try {
    String s =tfNote1.getText();
    if (s.equals(""))  throw new Exception("\nnote absente");
    note1=Double.parseDouble(s);
    s =tfNote2.getText();
    if (s.equals(""))  throw new Exception("\nnote absente");
    note2=Double.parseDouble(s);
    message += "\n\nvos notes sont "+df.format(note1)+" et "+df.format(note2);
    message += "\nmoyenne "+df.format((note1+note2)/2); 
    } catch(NumberFormatException ex) {message += "\n\nnote incorrecte";}
      catch(Exception ex) {message += ex.getMessage();}
    
    // affichage du message
    ta.setText(message);
    }

}


class TestFen3 {
  public static void main(String[] args) {
    Fenetre3 f = new Fenetre3("3");
    f.pack();
    f.show();
    }
}
