package dominos;
import es.Keyboard;
import java.util.Vector;

public class Grille {
  private int n,m;
  private Case[][] lesCases ;

  /** cre une grille de 'n'x'm' cases ('n' lignes et 'm' colonnes) */
  public Grille(int n, int m) {
    this.n=n;
    this.m=m;
    lesCases = new Case[n][m];
    for (int i=0;i<n;i++) for (int j=0;j<m;j++)
        this.lesCases[i][j]=new Case(i,j);
    }

   /** Teste si cette grille contient la case 'c' */
   public boolean contient (Case c) {
     return c.getX() >=0 && c.getY() >=0 && c.getX() < this.n
                        && c.getY() < this.m ; }

   /** pose la case 'c' sur cette grille */
   public void poser(Case c) {
     this.lesCases[c.getX()][c.getY()]=c;
     }

   /** Teste si la case 'c' de cette grille  est vide */
    public boolean vide(Case c) {
      return this.lesCases[c.getX()][c.getY()].vide();
      }

    /** Vide la case 'c' de cette grille */
    public void vider(Case c) {
       c.vider();
      }

  /** Teste si toutes les cases de cette grille sont remplies */
  public boolean pleine() {
    for (int i=0;i<n;i++)
      for (int j=0;j<m;j++) {
        if (this.lesCases[i][j].vide()) return false;
        }
    return true;
    }

  /** Renvoie une chaine de caractres reprsentant cette grille recouverte de dominos */
  public String toString() {
    String res = "\ngrille\n+";
     for ( int i=0;i<m;i++) res +=" -";
    res +=" +";
    for (int i=0;i<n;i++) {
      res += "\n| ";
      for (int j=0;j<m;j++)  res += this.lesCases[i][j]+" ";
      res += "|";
      }
    res +="\n+";
    for ( int i=0;i<m;i++) res +=" -";
    res +=" +";
    return res;
    }
}

/* pour des grilles >= 20 cases, on peut mettre des int au lieu de char
puis
DecimalFormat df = new DecimalFormat("00");
res += df.format(this.lesCases[i][j].getVal())+" "  (dfinir getVal()
et n'imprimer que les cases non nulles, 2 blancs sinon et ca marche

if (this.lesCases[i][j].getVal()==0) res += "   ";
                             else res += df.format(this.lesCases[i][j].getVal())+" ";


*/