package dominos;
import java.awt.*;

public class Case {
   private int x,y; // les coordonnes de cette case
   // private String val;
   private Button bouton ; // le bouton de cette case
   private static Color[] lesCouleurs = {Color.red, Color.blue, Color.yellow,
                            Color.green, Color.cyan, Color.orange, Color.pink};

  /** cre une case vide de coordonnes 'x' et 'y' */
  public Case(int x, int y) {
   /***************************************************************************
    * remplir les champs
    * mmoriser dans les bouton de cette case les valuers de x et y,
    * par exemple sous la forme de la chaine x+" "+y
    **************************************************************************/
   this.x=x;
   this.y=y;
   this.bouton = new Button();
   this.bouton.setActionCommand(x+" "+y);
   }

  /** Remplit cette case par la chaine 's' */
  public void remplir(String s) {
    int i= Integer.parseInt(s);
    this.bouton.setLabel(s);
    this.bouton.setBackground(lesCouleurs[i%7]);
    }

  /** Vide cette case */
  public void vider() {
     Button b = this.getBouton();
    b.setLabel("");
    b.setBackground(Color.lightGray);
    }

  /** Teste si cette case est vide */
  public boolean vide() {
    return (this.bouton.getLabel().equals(""));
    }

  /** Marque cette case */
  public void marquer() {
    Button b = this.getBouton();
    b.setLabel("X");
    b.setBackground(Color.white);
    }

  /** Teste si cette case est marque */
  public boolean marquee() {
    Button b = this.getBouton();
    return b.getBackground().equals(Color.white);
    }

  /** renvoie la premire coordonne de cette case */
  public int getX() {return this.x;}
  /** renvoie la deuxime coordonne de cette case */
  public int getY() {return this.y;}

  /** renvoie le b outon de cette case */
  public Button getBouton() { return this.bouton;}

  /** renvoie l'afichage de cette case */
  public String getVal() {
    return this.bouton.getLabel();
    }

  /** teste si cette case est adjacente  la case c */
  public boolean adjacente(Case c) {
    return(Math.abs(this.x-c.x)+Math.abs(this.y-c.y)==1);
    }
}
