package dominos;
import es.Keyboard;
import java.util.Vector;
import java.awt.*;

public class Grille {
  protected int n,m;
  protected Case[][] lesCases ;
  protected Panel p ;

  /** cre une grille de 'n'x'm' cases ('n' lignes et 'm' colonnes) */
  public Grille(int n, int m) {
    this.n=n;
    this.m=m;
    this.p = new Panel();
    this.lesCases = new Case[n][m];
    this.p.setLayout(new GridLayout(n,m));
    for (int i=0;i<n;i++) for (int j=0;j<m;j++) {
        this.lesCases[i][j]=new Case(i,j);
        this.p.add(this.lesCases[i][j].getBouton());
        }
    }

  /** Teste si toutes les cases de cette grille sont remplies */
  public boolean pleine() {
    for (int i=0;i<n;i++)
      for (int j=0;j<m;j++) {
        if (this.lesCases[i][j].vide()) return false;
        }
    return true;
    }

  /** renvoie le vecteur des cases adjacentes  la case c */
  protected  Vector voisines(Case c) {
     Vector v = new Vector();
     int x = c.getX();
     int y = c.getY();
     if (y>0) v.add(this.lesCases[x][y-1]);
     if (y<this.m-1) v.add(this.lesCases[x][y+1]);
     if (x>0) v.add(this.lesCases[x-1][y]);
     if (x<this.n-1)v.add(this.lesCases[x+1][y]);
     return v;
     }

}

