package gestion;
import java.util.Vector;

/** classe implmentant les donnes relatives  un tudiant (identit, groupe,
 *      notes, relev de notes) */
public class Etudiant {
  private Groupe groupe;
  private String nom;
  private String prenom;
  private int age;
  private Note[] tabNotes; // tableau de triplets (tudiant, matire, valeur)
  private String releve;

  /** construit un tudiant de nom 'nom' et prnom "prenom" */
  public Etudiant(String nom, String prenom) {
   this.nom = nom;
   this.prenom = prenom;
   }

  /** S'il n'y a pas d'tudiant 'nom' 'prnom'
   *    1) cre cet tudiant avec son 'groupe', son "age', ses notes 'valNotes',
   *       et son relev de notes 'relev'
   *            (Attention :
   *             'valNotes' est un tableau de double,
   *             'this.tabNotes' est un tableau  d'instances de la classe Note,
   *                      c'est--dire de triplets (etudiant, matire, valeur))
   *    2) enregistre les notes dans chaque matire de 'tabMatieres'.
   ** S'il y a dj un tudiant 'nom' 'prnom'
   *    1) enregistre les nouvelles valeurs de toutes les autres donnes
   *    2) met  jour les notes correspondantes dans les matires
   */
  public static Etudiant enregistrer(Groupe groupe, String nom, String prenom,
            int age, Matiere[] tabMatieres, double[] valNotes, String releve) {
   int nbMat = tabMatieres.length;
   Vector v = groupe.getVecEtudiants();
   Etudiant etu = null;
   boolean trouve = false;
   for (int i=0;i<v.size() && ! trouve;i++) {
     etu = (Etudiant)v.elementAt(i);
     if (etu.nom.equals(nom) && etu.prenom.equals(prenom)) {
       trouve = true ; // cet tudiant existe dj
       for (int j=0;j<nbMat;j++) {  // on retire ses notes des matires
         Note note = etu.tabNotes[j];
         Matiere mat = note.getMat();
         mat.getVecNotes().remove(note);
         }
       }
     }
   if (! trouve) {etu = new Etudiant(nom, prenom); v.addElement(etu);}
   etu.groupe=groupe;
   etu.age=age;
   etu.tabNotes= new Note[nbMat];
   for (int i=0; i<nbMat;i++) {
     Note note = new Note(etu, tabMatieres[i], valNotes[i]);
     etu.tabNotes[i]=note; // on enregistre sa note dans son tableau de notes
     tabMatieres[i].getVecNotes().add(note);
                           // et dans le vecteur de notes de chaque matire
     System.out.println("tabMatieres[i]="+tabMatieres[i]);
     }
   etu.releve=releve;
   return etu;
   }

  /** renvoie la moyenne des notes (note finale) de cet tudiant */
  public double moyenne() {
    int nbNotes = this.tabNotes.length;
    double somme = 0;
    for (int i=0;i<nbNotes;i++) {
      somme += this.tabNotes[i].getVal();
      }
    return somme/nbNotes;
    }

    /** renvoie le nom de cet tudiant */
    public String getNom() {return this.nom;}

    /** renvoie le nom de cet tudiant */
    public String getPrenom() {return this.prenom;}

  /*
    public String toString() {
      String s = this.nom+this.prenom+ this.age;
      for (int i=0;i<this.tabNotes.length;i++) {
        s += "\n"+ this.tabNotes[i].mat.nom+" : "+this.tabNotes[i].val;
        }
      s += "\nmoyenne : "+this.moyenne();
      return s;
  }
   */

}
