package gestion;
import java.util.Vector;
import java.text.*;

/** classe implmentant un groupe d'tudiants */
public class Groupe {
  private String nom;
  private Vector vecEtudiants = new Vector();

  /** cre un groupe de nom 'nom' */
  public Groupe(String nom) {
   this.nom=nom;
   }

  /** calcule la moyenne des notes finales des tudiants de ce groupe */
  public double moyenne() {
    double somme =0;
    int nbEtudiants = this.vecEtudiants.size();
    for (int i=0;i<nbEtudiants;i++) {
      somme += ((Etudiant)this.vecEtudiants.elementAt(i)).moyenne();
      }
    return somme /nbEtudiants;
    }

  /** renvoie le nom de ce groupe */
  public String getNom () {return this.nom;}

  /** renvoie le vecteur des tudiants de ce groupe */
  public Vector getVecEtudiants() {return this.vecEtudiants;}

  /** renvoie une reprsentation sous forme de chaine de caractres de ce
   *  groupe comportant la liste des tudiants avec leur note finale et la
   *  moyenne des notes finales des tudiants
   */
  public String toString() {
    DecimalFormat df = new DecimalFormat("0.##");
    String s = "\n\n========== notes finales du groupe "+this.nom
              +" ==========";
    int nbEtudiants = this.vecEtudiants.size();
    for (int i=0;i<nbEtudiants;i++) {
      Etudiant etu = (Etudiant)this.vecEtudiants.elementAt(i);
      s += "\n"+etu.getNom()+" "+etu.getPrenom()+" : "+df.format(etu.moyenne());
      }
    s += "\nmoyenne des notes finales des "+nbEtudiants+" tudiants du groupe "
          +this.nom+" : " +df.format(this.moyenne());
    return s;
    }


}
