package iv;
import java.util.Vector;

/** Implmente un cinma avec plusieurs salles, une caisse et une file d'attente. */
public class Cinema {
    private String nom;
    private Caisse c = new Caisse(100);
    private Salle[] lesSalles;
    private Vector lesFilms = new Vector();
    private FileAttente queue = new FileAttente();
    /** Cre un Cinema avec le nombre de salles spcifi et une caisse
     *  contenant 100 Euros. */
    public Cinema(String nom, int nbSalles) {
      this.nom=nom;
      this.lesSalles = new Salle[nbSalles];
      }
    /** Le film spcifi est projet dans la salle spcifie. */
    public void joue(Film film, Salle salle)  {
      this.lesFilms.addElement(film);
      salle.setFilm(film);
      film.setSalle(salle);
      }
    /** Le Cinephile spcifi rentre dans la file d'attende de ce Cinema. */
    public void entrer(Cinephile cph) { this.queue.rentrer(cph);}
    /** La premire personne de la file d'attente paie et rentre dans la salle
     *  o se projte le film qu'elle souhaite voir; le nombre de places
     *  restant dans la salle est mis  jour. */
    public void passer() {
       Cinephile cph = (Cinephile)this.queue.premier();
       if (cph != null) {
         String titre = cph.getTitreFilm();
         boolean trouve = false;
         for (int i=0; i<lesFilms.size() && ! trouve;i++)
           {Film film =( (Film)this.lesFilms.elementAt(i));
             if ( film.getTitre().equals(titre))
               {trouve = true;
                  double prix = film.getPrix();
                  Salle sa = film.getSalle();
                  cph.payerEtAllerDansSalle(prix, this.c, sa);
                }
           }
         this.queue.sortir();
         }
       }

    /** Renvoie les salles de ce cinma. */
    public Salle[] getLesSalles() { return this.lesSalles;}
    /** Renvoie la file d'attente de ce cinma. */
    public FileAttente getQueue() { return this.queue;}
    /** Renvoie la caisse de ce cinma. */
    public Caisse getCaisse() { return this.c;}
    /** Renvoie une reprsentation sous forme de chaine de ce cinma. */
    public String toString() {
      String s = "=====\ncinma : "+this.nom+ ", "+this.lesSalles.length
                +" salles, "+this.lesFilms.size()+" films projets ";
      for (int i=0;i<this.lesSalles.length;i++)
        s+="\nsalle "+i+" : "+lesSalles[i].getFilm()+", "
          +this.lesSalles[i].getNbPlaces()+" places libres";
      s+="\n"+this.queue+"\n"+this.c;
      return s+"\n=====";
      }
}
