package ab;

/** Implmentation d'arbres binaires et de plusieurs reprsentations. */
public class ArbreBinaire {
  /*private*/ protected Object racine; // protected pour numrations
  /*private*/ protected ArbreBinaire gauche,droit;// sous-arbres gauche et droit

  /** Cre un arbre binaire compos d'un seul noeud (cad une feuille). */
  public ArbreBinaire(Object racine) { this.racine=racine;}

  /** Cre un arbre binaire compos de la racine spcifie et des deux
   *  sous-arbres spcifis */
  public ArbreBinaire(Object racine, ArbreBinaire gauche, ArbreBinaire droit) {
    this(racine);
    this.gauche=gauche;
    this.droit=droit;
    }

   /** Cre un arbre binaire compos de la racine spcifie et du sous-arbre
    *  spcifi (qui sera les sous-arbre droit). */
  public ArbreBinaire(Object racine, ArbreBinaire droit) {
   this(racine, null,droit);
   }

  /** Teste si cet Arbre binaire est une feuille. */
  public boolean feuille() {
    return this.gauche == null && this.droit == null ;
    }

  /** Renvoie une reprsentation indente de cet arbre binaire, c'est--dire :
   *  pour chaque sous-arbre il y a passage  la ligne et une indentation
   *  proportionnelle  la profondeur de ce sous-arbre. */
   public String toString() { return this.toString("");}
   /** Renvoie une reprsentation indente de cet arbre binaire indente de plus
    *  de la chaine spcifie. */
   public String toString(String indent) {
      String s= indent;
      s+=this.racine;
      indent += "   ";
      if (!(this.gauche==null)) s+="\n"+this.gauche.toString(indent);
      if (!(this.droit==null)) s+="\n"+this.droit.toString(indent);
      return s;
      }

  /** Renvoie une reprsentation prfixe de cet arbre binaire,
   *  c'est--dire dans l'ordre : 
   *  racine puis sous-arbres gauche puis droit prfixs. */
  public String formePrefixe() {
    String s = ""+this.racine;
    if (this.gauche != null) s+=" "+ this.gauche.formePrefixe();
    if (this.droit != null) s+= " "+this.droit.formePrefixe();
    return s;
    }

  /** Renvoie une reprsentation postfixe de cet arbre binaire,
  *  c'est--dire dans l'ordre : 
  *  sous-arbres gauche puis droit postfixs puis racine. */
  public String formePostfixe() {
   String s = "";
   if (this.gauche != null) s+= this.gauche.formePostfixe();
   if (this.droit != null) s+= this.droit.formePostfixe();
   s+=" "+this.racine;
   return s;
   }

   /** Renvoie une reprsentation infixe de cet arbre binaire,
    *  c'est--dire dans l'ordre :
    *  sous-arbre gauche infixe puis racine puis sous-arbre droit infixe. */
   public String formeInfixe() {
      String s="";
      if (this.gauche != null) s+= this.gauche.formeInfixe();
      s+=" "+this.racine;
      if (this.droit != null) s+= this.droit.formeInfixe();
      return s ;
      }

    /** Renvoie une reprsentation infixe de cet arbre binaire dans laquelle
     *  chaque sous-arbre est entour de parenthses sauf les feuilles. */
    public String formeInfixePar() {
      boolean par = false;
      if (! this.feuille()) par = true;
      String s="";
      if (par) s+= " (";
      if (this.gauche != null) s+= this.gauche.formeInfixePar();
      s+=" "+this.racine;
      if (this.droit != null) s+= this.droit.formeInfixePar();
      if (par) s+=" )";
      return s ;
      }

    public String formePrefixeEn() {
      String s = "";
      for (EnumerationPrefixe e = new EnumerationPrefixe(this);
                                           e.hasMoreElements();)
         s+=e.nextElement()+" ";
         return s;
         }

        //
        // Reprsentations pr/post/infixes utilisant des numrations
        //

     public String formePostfixeEn() {
       String s = "";
       for (EnumerationPostfixe e = new EnumerationPostfixe(this);
                                              e.hasMoreElements();)
         s+=e.nextElement()+" ";
         return s;
         }
     public String formeInfixeEn() {
       String s="";
       for (EnumerationInfixe e = new EnumerationInfixe(this);
                                          e.hasMoreElements();)
         s+=e.nextElement()+" ";
         return s ;
         }
     public String formeInfixeParEn() {
       String s="";
       for (EnumerationInfixePar e = new EnumerationInfixePar(this);
                                                e.hasMoreElements();)
         s+=e.nextElement()+" ";
         return s ;
         }
}
