package matrices;
import es.Clavier;
// import java.lang.Math;

/** implmention de matrices par des tableaux  2 dimensions
 *  on fera mieux plus tard !
 */
public class Matrices {

  /** cre et renvoie la matrice somme des deux matrices 'mat1' et 'mat2'.
   *  si les dimensions ne sont pas les mmes, renvoie une matrice vide. */
  public static int[][] somme(int[][] mat1, int[][] mat2) {
    int n = mat1.length;
    int m = (n>0) ? mat1[0].length : 0;
    int n2 = mat2.length;
    int m2 = (n2>0) ? mat2[0].length : 0;
    if(n != n2 || m != m2) {n=0;m=0;};
    int[][] mat = new int[n][m];
    for (int i=0; i<n;i++)
      for (int j=0; j<m;j++)
        mat[i][j] = mat1[i][j] + mat2[i][j];
    return mat;
    }
  /** cre et renvoie la matrice somme des deux matrices 'mat1' et 'mat2'.
   *  si les dimensions ne sont pas correctes, renvoie une matrice vide. */
  public static int[][] produit(int[][] mat1, int[][] mat2) {
    int n = mat1.length;
    int m = (n>0) ? mat1[0].length:0;
    int n2 = mat2.length;
    int p = (n2>0) ? mat2[0].length:0;
    if(m != n2) {n=0;p=0;};
    int[][] mat = new int[n][p];
    for (int i=0; i<n;i++)
      for (int j=0; j<p;j++) {
        mat[i][j] = 0;
         for (int k=0;k<m;k++) mat[i][j] += mat1[i][k] * mat2[k][j];
         }
    return mat;
    }

  /** cre et renvoie une matrice de dimensions 'n' et 'm' remplie alatoirement
   *  par des nombres entiers positifs ou nuls plus petits que 100
   */
   public static int[][] creerMatAlea(int n, int m) {
    int[][] mat = new int[n][m];
    for (int i=0;i<n;i++)
      for (int j=0;j<m;j++)
        mat[i][j] = (int) Math.floor(20*Math.random());
    return mat;
    }
  /** renvoie une chaine reprsentant la matrice 'mat' */
  public static String toString(int[][] mat) {
    String s = "";
    for (int i=0;i<mat.length;i++) {
      for (int j=0;j<mat[0].length;j++) s += "  "+mat[i][j];
      s += "\n";
      }
    return s;
    }

    /** programme de test d somme et produit de matrices alatoires dont les
     *  dimensions sont lues au clavier
     */
    public static void main(String[] args) {
      int n = Clavier.lireInt("nombre de lignes : ");
      int m = Clavier.lireInt("nombre de colonnes : ");
      int[][] mat1 = creerMatAlea(n,m);
      int[][] mat2 = creerMatAlea(n,m);
      System.out.println("\nmat1=\n"+toString(mat1)+"\nmat2=\n"+toString(mat2));
      System.out.println("mat1+mat2=\n"+toString(somme(mat1,mat2)));
      int p = Clavier.lireInt(
                     "nombre de colonnes de la 2me matrice pour le produit : ");
      mat2 = creerMatAlea(m,p);
      System.out.println("\nmat1=\n"+toString(mat1)+"\nmat2=\n"+toString(mat2));
      System.out.println("mat1*mat2=\n"+toString(produit(mat1,mat2)));
      }
}

/*

nombre de lignes : 2
nombre de colonnes : 2

mat1=
  1  2
  9  9

mat2=
  9  15
  5  2

mat1+mat2=
  10  17
  14  11

nombre de colonnes de la 2me matrice pour le produit : 2

mat1=
  1  2
  9  9

mat2=
  2  0
  14  8

mat1*mat2=
  30  16
  144  72

*******************************

nombre de lignes : 3
nombre de colonnes : 4

mat1=
  10  15  17  1
  10  12  10  18
  18  14  9  2

mat2=
  3  17  18  15
  1  6  8  11
  12  1  16  10

mat1+mat2=
  13  32  35  16
  11  18  18  29
  30  15  25  12

nombre de colonnes de la 2me matrice pour le produit : 5

mat1=
  10  15  17  1
  10  12  10  18
  18  14  9  2

mat2=
  6  9  1  13  19
  0  14  19  16  4
  14  8  13  18  19
  6  8  2  13  2

mat1*mat2=
  304  444  518  689  575
  308  482  404  736  464
  246  446  405  646  573

*/