package tableaux;
import bibliDP.es.Clavier;

/** manipulations de tableaux */
public class Sommes {
  /** renvoie une chaine de caractres reprsentant le tableau 'tab' */
  public static String toString(int[] tab) {
    String chaine = "";
    for (int i=0;i<tab.length;i++) chaine +=" "+tab[i];
    chaine += "\n";
    return chaine;
    /* ou mieux
    StringBuffer chaine = new StringBuffer();
    for (int i=0;i<tab.length;i++) chaine.append(" "+tab[i]);
    chaine.append("\n");
    return chaine.toString();
    */
    }
  /** renvoie la somme des lments du tableau 'tab' */
  public static int somme(int[] tab) {
    int s=0;
    for (int i=0;i<tab.length;i++)  s += tab[i];
    return s;
    }
  /** renvoie la moyenne des lments du tableau 'tab' */
  public static double moyenne(int[] tab) {
    return (double)somme(tab)/tab.length;
    }
  /** cre et renvoie un tableau qui est la somme terme  terme de 'tab1' et 
   * 'tab2'et dont la dimension est la plus petite des deux dimensions */
  public static int[] somme(int[] tab1, int[] tab2) {
    int n = Math.min(tab1.length, tab2.length);
    int[] tab = new int[n];
    for (int i=0;i<n;i++) tab[i]= tab1[i]+tab2[i];
    return(tab);
    }
  /** renvoie le produit scalaire de 'tab1' et 'tab2' */
  public static int produitScalaire(int[] tab1, int[] tab2) {
    int n = Math.min(tab1.length, tab2.length);
    int prod = 0;
    for (int i=0;i<n;i++) prod += tab1[i]*tab2[i];
    return(prod);
    }
  /** cre un tableau de dimension 'n' et 
   *  le remplit par des lectures au clavier */
  public static int[] creerEtLire(int n) {
    int[] tab = new int[n];
    System.out.println("tapez "+n+" nombres entiers");
    for (int i=0;i<n;i++) tab[i]=Clavier.readInt();
    return tab;
    }
  /** renvoie une chaine reprsentant le tableau de tableaux 'tab' */
  public static String toString(int[][] tab) {
    String chaine = "";
    for (int i=0;i<tab.length;i++) {
      for (int j=0; j<tab[i].length;j++) chaine +=" "+tab[i][j];
      chaine += "\n";
      }
    return(chaine);
    }
  /** renvoie la somme des lments du tableau de tableaux 'tab' */
  public static int somme(int[][] tab) {
    int s=0;
    for (int i=0;i<tab.length;i++)
      for (int j=0; j<tab[i].length;j++) s += tab[i][j];
    return s;
    }
  /** cre et renvoie un tableau qui est la somme de 'tab1' et 'tab2' */
  public static int[][] somme(int[][] tab1, int[][] tab2) {
    int n = Math.min(tab1.length, tab2.length);
    int[][] tab = new int[n][];
    for (int i=0;i<n;i++) {
      int m = Math.min(tab1[i].length,tab2[i].length);
      tab[i] = new int[m];
      for (int j=0; j<m;j++) {
        tab[i][j] = tab1[i][j]+tab2[i][j];
        }
      }
    return(tab);
    }
  /** cre un tableau  2 dimensions 'n' et 'm' et  
   *  le remplit par des lectures au clavier */
  public static int[][] creerEtLire(int n,int m) {
    int[][] tab = new int[n][m];
    System.out.println("tapez "+n*m+" nombres entiers");
    for (int i=0;i<n;i++) for (int j=0;j<m;j++) tab[i][j]=Clavier.readInt();
    return tab;
    }
  /** programme de test qui
   *   affiche la somme des lements d'un tableau  1 (resp 2) dimension(s)
   *           la somme et le produit de deux tableaux  1 (resp 2) dimension(s)   *        pour des tableaux dfinis dans le programme
   *   puis affiche la somme des lments de tableaux lus au clavier.
   */
  public static void main(String[] args) {
    int[] t1={5,8,3,10,6};
    System.out.println("t1 : "+ toString(t1)); 
    System.out.println("somme  = "+somme(t1));
    System.out.println("moyenne  = "+moyenne(t1)+"\n");
    int[] t2={3,1,2};
    System.out.println("t2 : "+toString(t2)); 
    int[] t = somme(t1,t2);
    System.out.println("t1+t2 : "+ toString(t));
    int p = produitScalaire(t1,t2);
    System.out.println("t1.t2 : "+ p + "\n");
    int[][] tt1={{7,4,9,7},{6,7},{5,3,5}};
    System.out.println("tt1 : \n"+toString(tt1)); 
    System.out.println("somme = "+somme(tt1)+"\n");
    int[][] tt2={{7,4,9},{6,7,8},{5,3},{1,1,1,1,1}};
    System.out.println("tt2 : \n"+toString(tt2));
    int[][] tt = somme(tt1,tt2);
    System.out.println("tt1+tt2 : \n"+toString(tt));

    int n = Clavier.readInt("dimension ? ");
    int[] t3 = creerEtLire(n);
    System.out.println("t3 : "+toString(t3)+"\nsomme = "+somme(t3)
                        +"\nt1+t3 : "+toString(somme(t1,t3))); 

    n = Clavier.readInt("dimension1 ? ");
    int m = Clavier.readInt("dimension2 ? ");
    int[][] tt3 = creerEtLire(n,m);
    System.out.println("tt3 : \n"+toString(tt3)+"\nsomme = "+somme(tt3)
                        +"\ntt1+tt3 :\n"+toString(somme(tt1,tt3))); 

  }
}

/*

t1 :  5 8 3 10 6

somme  = 32
moyenne  = 6.4

t2 :  3 1 2

t1+t2 :  8 9 5

t1.t2 : 29

tt1 :
 7 4 9 7
 6 7
 5 3 5

somme = 53

tt2 :
 7 4 9
 6 7 8
 5 3
 1 1 1 1 1

tt1+tt2 :
 14 8 18
 12 14
 10 6

dimension ? 5
tapez 5 nombres entiers
5 6 7 5 2
t3 :  5 6 7 5 2

somme = 25
t1+t3 :  10 14 10 15 8

dimension1 ? 3
dimension2 ? 4
tapez 12 nombres entiers
1 2 3 4 5 6 7 8 9 10 11 12
tt3 :
 1 2 3 4
 5 6 7 8
 9 10 11 12

somme = 78
tt1+tt3 :
 8 6 12 11
 11 13
 14 13 16

*/
