package complexe;

/** dfinition des nombres complexes et quelques oprations */
  public class Complexe {
  private double re;
  private double im;

  /** Cre un Complexe dont les parties relle et imaginaire sont spcifies.
   * @param x la partie relle
   * @param y la partie imaginaire */
  public Complexe(double x, double y) {
    this.re=x;
    this.im=y;
    }

  /** Renvoie une reprsentation sous forme de chaine de ce Complexe,
   *  les 0 ne sont pas pris en compte,*/
  public String toString() {
    double a = this.re;
    double b = this.im;
    if (a==0 && b==0) return("0");
    if (a!=0 && b==0) return(""+a);
    if (a==0 && b>0) return("i "+b);
    String signei;
    String res="";
    if (a!=0) res+=a;
    if (b>0) signei=" + i "; else {signei=" - i "; b=-b;};
    return(res+signei+b);
    }

  // mthodes d'instance

  /** Renvoie la somme de ce Complexe et du Complexe spcifi.
   * @param c le Complexe  ajouter */
  public Complexe somme(Complexe c) {
    return (new Complexe(this.re+c.re, this.im+c.im));
    }

  /** Renvoie le produit de ce Complexe et du Complexe spcifi.
   * @param c le Complexe par lequel multiplier */
  public Complexe produit(Complexe c) {
    return (new Complexe(this.re*c.re - this.im*c.im,
                         this.re*c.im + this.im*c.re));
    // ou
    // return produit(this,c);
    // Attention, on ne peut pas dfinir  la fois la mthode d'instance 
    //  partir de la mthode statique et la mthode statique  partir 
    // de la mthode d'instance. Pourquoi ?
    }

  /** Renvoie le produit de ce Complexe et du double spcifi.
   * @param d le double par lequel multiplier */
  public Complexe produit(double d ) {
    return (new Complexe(this.re*d, this.im*d));
    }

  /** Renvoie l'inverse de ce Complexe */
  public Complexe inverse() {
    /*
    double a=this.re;
    double b=this.im;
    double carreNorme=a*a+b*b;
    return (new Complexe(a/carreNorme, -b/carreNorme));
    */
    // ou
    return this.conjugue().produit(1/this.carreNorme());
    }

  /** Renvoie le conjugu de ce Complexe */
  public Complexe conjugue() {
    return new Complexe(this.re,-this.im);
    }

  /** Renvoie le carr de la norme de ce Complexe */
  public double carreNorme() {
    return this.re*this.re + this.im*this.im;
    }

  /** Renvoie la norme de ce Complexe */
  public double norme() {
    return Math.sqrt(this.carreNorme());
    }
 
  // mthode de classe

  /** Renvoie la somme des deux Complexe spcifis.
   * @param c1 le premier Complexe
   * @param c2 le deuxime Complexe */
  public static Complexe somme(Complexe c1, Complexe c2) {
    return (new Complexe(c1.re+c2.re, c1.im+c2.im));
    // ou
    // return c1.somme(c2);
    // Attention, on ne peut pas dfinir  la fois la mthode statique 
    //  partir de la mthode d'instance et la mthode d'instance  partir 
    // de la mthode d'instance. Pourquoi ?
    }

  /** Renvoie le produit des deux Complexe spcifis.
   * @param c1 le premier Complexe
   * @param c2 le deuxime Complexe */
  public static Complexe produit(Complexe c1, Complexe c2) {
    return (new Complexe(c1.re*c2.re - c1.im*c2.im,
                         c1.re*c2.im + c1.im*c2.re));
    }

  /** Renvoie l'inverse du Complexe spcifi.
   * @param c le Complexe */
  public static Complexe inverse(Complexe c) {
    double a=c.re;
    double b=c.im;
    double norme=a*a+b*b;
    return new Complexe(a/norme, -b/norme);
    }

}

