package vecteurs;
import java.util.Vector;
import java.util.Random;
import bibliDP.es.Clavier;

/** Exercice sur les Vector; implementations de mthodes statiques */
public class InitialisationsEtSommes {
  /** Renvoie la somme des lments du Vector d'entiers spcifi.
   *  @param v le Vector.
   *  @return la somme.
   */
  public static int somme(Vector v) {
    int s=0;
    for (int i=0; i<v.size();i++) s += ((Integer)v.elementAt(i)).intValue();
    return s;
    }
  /** Cre et renvoie un Vector d'entiers qui est la somme terme  terme
   *  des lments de deux Vector d'entiers spcifis.
   *  La taille de ce Vector est la plus petite des tailles des deux Vector.
   *  @param v1 le premier Vector.
   *  @param v1 le deuxime Vector.
   *  @return le Vector cr.
   */
  public static Vector somme(Vector v1, Vector v2) {
    Vector v = new Vector();
    int n = Math.min(v1.size(), v2.size());
    for (int i=0;i<n;i++) {
      int i1= ((Integer) v1.elementAt(i)).intValue();
      int i2= ((Integer) v2.elementAt(i)).intValue();
      v.addElement(new Integer(i1+i2));
      }
      return v;
    }
  /** Cre et renvoie un Vector dont le nombre d'lments et les lements,
   *  reprsentant des entiers, sont lus au clavier. */
  public static Vector creerEtLire() {
    Vector v = new Vector();
    int n = Clavier.readInt("nombre d'lments : ");
    System.out.print("les " + n + " nombres : ");
    for (int i=0;i<n;i++) v.addElement(new Integer(Clavier.readInt()));
     // ou
    // for (int i=0;i<n;i++) v.addElement(new Integer(Clavier.readString()));
    // ou
   // for (int i=0;i<n;i++) v.addElement(Integer.valueOf(Clavier.readString()));
    return(v);
    }
  /** Cre et renvoie un Vector d'entiers dont les lments reprsentent les
   *  entiers reprsents par les chaines du tableau de String spcifi.
   *  @param tab un tableau de String reprsentant des entiers.
   *  @return un Vector d'Integer.
   *  Cette mthode pourra tre utilise en particulier pour donner des entiers
   *  en arguments de la commande java. */
  public static Vector remplirPar(String[] tab) {
    Vector v = new Vector();
    int n = tab.length;
    for (int i=0;i<n;i++) v.addElement(Integer.valueOf(tab[i]));
    return(v);
    }
  /** Cre et renvoie un Vector rempli alatoirement par des lments 
   *  reprsentant des entiers compris entre 0 (inclus) et 'n' (exclus). */
  public static Vector remplirAlea(int n) {
    Vector v = new Vector();
    Random gen = new Random();
     for (int i=0;i<n;i++) v.addElement(new Integer(gen.nextInt(100)));
    return(v);
    }

  /** Teste les mthodes de cette classe */
  public static void main(String[] args) {
    Vector v= new Vector();
    v.addElement(new Integer(5));
    v.addElement(new Integer(12));
    v.addElement(new Integer(45));
    System.out.println("v = "+v);
    Vector v1 = new Vector();
    for (int i=0;i<5;i++)  v1.addElement(new Integer(i));
    System.out.println("v1 = "+v1+"\nsomme = "+somme(v1));
    System.out.println("v+v1 = "+somme(v,v1));
    v=creerEtLire();
    System.out.println("vecteur lu="+v+" somme = "+ somme(v));
    v=remplirPar(args);
    System.out.println("vecteur args="+v+" somme = "+ somme(v));
    v=remplirAlea(9);
    System.out.println("vecteur alatoire ="+v+" somme = "+ somme(v));
    }
}

/*

v = [5, 12, 45]
v1 = [0, 1, 2, 3, 4]
somme = 10
v+v1 = [5, 13, 47]
nombre d'lments : 3
les 3 nombres : 8 9 2
vecteur lu=[8, 9, 2] somme = 19
vecteur args=[4, 7, 5, 8, 3] somme = 27
vecteur alatoire =[57, 92, 39, 13, 33, 5, 48, 46, 31] somme = 364

*/
