package etablissement;

import java.util.Vector;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.text.DecimalFormat;

/** classe Eleve avec nom, prnom, date et ville de naissance, notes */
public class Eleve{

	private String nom;
	private String prenom;
	private GregorianCalendar dateNaissance;
	private String ville;
	private Vector lesNotes;

/** le constructeur  partir du 'nom', du 'prenom',
 * de la 'dateNaissance'  et de la 'ville' o habite l'lve */

  public Eleve(String nom,String prenom,GregorianCalendar dateNaissance,
	             	String ville){
    this.nom=nom; this.prenom=prenom; this.dateNaissance=dateNaissance;
    this.ville=ville; this.lesNotes=new Vector();
	}

/**  ajout d'une 'note'  l'lve */

  public void ajouterNote(double note){
  // mieux que float pour ne pas avoir  taper 8.5f
    lesNotes.addElement(new Double(note));
	}

/** renvoie la moyenne des notes de cet lve */
  public double getMoyenne(){
    double somme=0;
    for (int i=0;i<this.lesNotes.size();i++){
      somme+=((Double) this.lesNotes.elementAt(i)).doubleValue();}
      // (Double) parce que les lments d'un vecteur sont des Objet
      // doubleValue pour passer de la classe Double (qui est Objet)
      // au type double
      return(somme/this.lesNotes.size());
      }

/** renvoie les rsultats de l'Eleve sous forme de String
 * (nom, anne de naissance, ville, notes et moyenne */

  public String toString() {
    DecimalFormat df = new DecimalFormat("0.00"); // 2 dcimales
    return("\n      "+this.nom+" "+this.prenom
          +" ne(e) le "+  this.dateNaissance.get(Calendar.DAY_OF_MONTH)
          + "/"+this.dateNaissance.get(Calendar.MONTH)
          + "/"+this.dateNaissance.get(Calendar.YEAR)
          + " a "+ this.ville
          +"\n         Notes:"+ this.lesNotes
       // +"\n         Moyenne de l eleve: "+getMoyenne());
          +"\n         Moyenne de l eleve: "+df.format(getMoyenne()));
        }
}

