
package repertoires;

import java.util.Vector;

/** Implmente des rpertoires ayant un nom et
 *      comprenant des noms et numros de tlphone.
 *  Tous les noms doivent tre diffrents.
 */
public class Repertoire1 {
    private String nomDuRepertoire;
    private Vector lesNoms;
    private Vector lesTels;
    private static Vector tousLesRepertoires = new Vector();

/** cree un nouveau repertoire avec le nom spcifi */
    public Repertoire1(String nomDuRepertoire){
	    this.nomDuRepertoire=nomDuRepertoire;
	    this.lesNoms=new Vector();
	    this.lesTels=new Vector();
            Repertoire1.tousLesRepertoires.addElement(this);
	}

/** ajoute dans ce rpertoire un nom et son tlphone
  * si le nom existe dj, modifie le tlphone */
    public void ajouter(String nom, String tel){
      // version 1
      /*1
      for (int i=0; i<this.lesNoms.size();i++)
        if (this.lesNoms.elementAt(i).equals(nom)) {
            this.lesTels.setElementAt(tel,i); return;
            }
      this.lesNoms.addElement(nom);
      this.lesTels.addElement(tel);
      1*/
      // version 2
      //*2
      int i  = this.lesNoms.indexOf(nom);
      if (i>=0) this.lesTels.setElementAt(tel,i);
      else { this.lesNoms.addElement(nom);
             this.lesTels.addElement(tel);
             }
      //2*/

      }



/** renvoie le numro de tlphone correspondant au  nom spcifi,
 *  renvoie null s'il n'y en a pas */
    public String getTel(String nom){
      // version 1
      /*1
      for (int i=0; i<this.lesNoms.size();i++)
        if (this.lesNoms.elementAt(i).equals(nom))
        return((String) this.lesTels.elementAt(i));
      1*/
      // version 2
      //*2
      int i = this.lesNoms.indexOf(nom);
      if (i>=0) return((String) this.lesTels.elementAt(i));
      //2*/
      return null;
    }

/** supprime de ce rpertoire le nom spcifi et son tlphone */
    public void supprimer(String nom) {
      // version 1
      /*1
      for (int i=0; i<this.lesNoms.size();i++)
        if (this.lesNoms.elementAt(i).equals(nom)) {
           this.lesNoms.removeElementAt(i);
           this.lesTels.removeElementAt(i);
           return;
           }
      1*/
      // version 2
      //*2
      int i = this.lesNoms.indexOf(nom);
      if (i>=0) {this.lesNoms.removeElementAt(i);
                 this.lesTels.removeElementAt(i);
                 }
      return;
      //2*/

      }


/** renvoie une reprsentation sous forme de chane de caractres de
 *  ce rpertoire */
  public String toString() {
    String res="\nrpertoire \""+ this.nomDuRepertoire+"\""+
            "\nnom  - tl\n===============\n";

      for (int i=0;i<this.lesNoms.size();i++)
      res += this.lesNoms.elementAt(i)+" : "
            +this.lesTels.elementAt(i).toString()+"\n";
      return res+"===============\n";
      }


/** renvoie le rpertoire dont le nom est spcifi,
 *  cre le rpertoire s'il n'existe pas */
 public static Repertoire1 getRepertoire(String nomDuRepertoire) {
   for (int i=0; i<Repertoire1.tousLesRepertoires.size();i++) {
      Repertoire1 r = ((Repertoire1)Repertoire1.tousLesRepertoires.elementAt(i));
      if (r.nomDuRepertoire.equals(nomDuRepertoire)) return(r);}
      return new Repertoire1(nomDuRepertoire);
      }

/** renvoie une reprsentation sous forme de chane de caractres de
 *  tous les rpertoires */
  public static String tousLesRepertoiresToString() {
    StringBuffer sb = new StringBuffer("\nliste de tous les rpertoires\n");
    for (int i=0;i<tousLesRepertoires.size();i++)
      sb = sb.append(tousLesRepertoires.elementAt(i));
      return sb.toString();
      }
}
