package comptesDerives;
import java.util.Date;
import java.text.DecimalFormat;
import comptes.Compte0;

public class Compte extends Compte0{

 protected /*private*/ double decouvertAutorise; 
 protected /*private*/ static double decouvertAutoriseParDefaut =100; 
 
 // constructeurs
 public Compte(String nomTitulaire) {
   super(nomTitulaire);
   this.decouvertAutorise = Compte.decouvertAutoriseParDefaut;
   }
 
 public static final int ESPECES = 0; 
 public static final int CHEQUE = 1;
 public static final int CB = 2;
 public static final int VIREMENT = 3;

 public Compte(String nomTitulaire, double versementInitial, int moyenPaiement,
               double decouvertAutorise) {
   this(nomTitulaire);
   this.crediter(versementInitial, moyenPaiement);
   }
 public Compte(String nomTitulaire,double versementInitial,int moyenPaiement) {
   this(nomTitulaire, versementInitial, moyenPaiement,
                                            Compte.decouvertAutoriseParDefaut);
   }

 public static final String[] lesMoyensPaiement =
                              {"espces ", "chque  ", "CB      ", "virement"};
 public static final DecimalFormat df = new DecimalFormat("###0.00");
 
public void crediter(double montant, int moyenPaiement) {
   if (montant > 0) this.enregistrer(montant, moyenPaiement);
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - crdit non effectu");}
 public void enregistrer(double montant, int moyenPaiement) {
   super.enregistrer(montant);
   this.releve.removeElement(this.releve.lastElement());
   String date = new Date().toString();
   date = date.substring(4,16)+date.substring(23,28);
   this.releve.addElement(date+" "+lesMoyensPaiement[moyenPaiement]+
               ((montant >0)?" crdit +":" dbit  ")+Compte.df.format(montant));
   }
 public void debiter(double montant, int moyenPaiement) {
   if (montant > 0)
     if (this.isDebitPossible(montant))this.enregistrer(-montant,moyenPaiement);
     else System.out.println("dbit non autoris, solde insuffisant");
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - dbit non effectu");}
 public boolean isDebitPossible(double montant) {
                           return montant < this.getSolde()+this.decouvertAutorise;}
 public void virer(double montant, Compte c) {
   if (montant >0)
      if (isDebitPossible(montant)) {
         this.debiter(montant, Compte.VIREMENT);
         c.crediter(montant, Compte.VIREMENT);
         }
      else System.out.println("dbit non autoris");
   else System.out.println(
          "erreur : vous avez donn un montant ngatif - virement non effectu");
   }
public String getReleve() {
  StringBuffer sb = new StringBuffer(this.toString()+"relev : \n");
  for (int i=0; i<this.releve.size();i++)
            sb.append(this.releve.elementAt(i)+"\n");
  return sb.toString();
  }

 public String toString() {
   String s = "\n==================\n"
            + this.RIB() + "\nsolde : " + Compte.df.format(this.getSolde())
            + "\ndcouvert autoris : " + Compte.df.format(this.decouvertAutorise);
   if (this.getSolde() < 0) s += "\nvous tes en dcouvert";
   s+="\n==================\n";
   return s;
   }

 public double getDecouvertAutorise() {return this.decouvertAutorise;}
 public void setDecouvertAutorise(double decouvertAutorise) {
   if (decouvertAutorise >0) this.decouvertAutorise = decouvertAutorise;}
 public static double getDecouvertAutoriseParDefaut() {
                                   return Compte.decouvertAutoriseParDefaut;}
 public static void setDecouvertAutoriseParDefaut(double decouvertAutoriseParDefaut) {
   if (decouvertAutoriseParDefaut >0)
                 Compte.decouvertAutoriseParDefaut = decouvertAutoriseParDefaut;}

}
