package matrices;

import java.text.DecimalFormat;

/** implmentation des matrices   2 dimensions */
public class Matrice {
  // protected int n, m;        // dclars protected pour pouvoir
  // protected int [][] tab;    // tre utiliss dans les sous-classes
  // ou
  private  int n, m;       // il faudra dfinir getN
  private int [][] tab;    // et getTab pour les sous-classes

/** cre une Matrice nulle de dimensions 'n' et 'm' */
  public Matrice(int n, int m) {
    this.n=n; this.m=m;
    this.tab= new int[n][m];
    }

/** cre une matrice de dimensions 'n' et 'm' remplie par les
 * lments du tableau 'tab'
 * si une ligne du tableau est trop courte ou trop longue elle
 * est complte par des 0 ou tronque
 * s'il n'y a pas assez de lignes on complte par des 0, s'il y a
 * trop de lignes, les dernires ne sont pas prises en compte
 */
   public Matrice(int n, int m, int [][] tab) {
    this(n,m);
    for (int i=0; i<tab.length && i<n; i++) {
       for (int j=0;j<tab[i].length && j<m;j++) this.tab[i][j]=tab[i][j];
       }
    }

/** cre une matrice remplie par les lments du tableau 'tab'
 * ventuellement complt par des 0 dont la premire dimension
 * est gale au nombre de lignes de 'tab' et la deuxime dimension
 * est gale au plus grand nombre d'lments dans les lignes de 'tab'
 */
   public Matrice(int [][] tab) {
     this.n = tab.length;
     this.m=0;
     for (int i=0;i<n;i++) if (tab[i].length>m) m = tab[i].length;
     System.out.println("n="+n+" m="+m);
     this.tab = new int[this.n][this.m];
     for (int i=0;i<n;i++) for (int j=0;j<tab[i].length;j++)
         this.tab[i][j]=tab[i][j];
     }

/** rend une reprsentation sous forme de chaine de cette Matrice */
 public String toString() {
  DecimalFormat df =new DecimalFormat("0000");
    StringBuffer res=new StringBuffer();
    res.append("n="+this.n+" m="+this.m+"\n");
    for (int i=0; i<this.n; i++) {
       for (int j=0; j<this.m; j++)
          res.append(df.format((this.tab[i][j]))+" ");
       res.append("\n");
       }
    return res.toString();
  }

/** rend si possible la Matrice somme de cette Matrice et de la Matrice
 * 'mat' sinon rend null
 */
  public Matrice somme(Matrice mat){
    if (this.n != mat.n || this.m != mat.m) return(null);
    Matrice som = new Matrice(this.n,this.m);
    for (int i=0; i<this.n; i++)
       for (int j=0;j<mat.m;j++)
           som.tab[i][j]=this.tab[i][j]+mat.tab[i][j];
    return som;
    }

/** rend si possible la Matrice produit de cette Matrice et de la Matrice
 * 'mat' sinon rend null */
  public Matrice produit(Matrice mat) {
    if (this.m != mat.n) return(null);
    Matrice pro = new Matrice(this.n,mat.m);
    for (int i=0; i<this.n; i++)
       for (int j=0;j<mat.m;j++) {
          pro.tab[i][j]=0;
          for (int k=0; k<this.m; k++)
                  pro.tab[i][j]+=this.tab[i][k]*mat.tab[k][j];
          }
    return pro;
    }
 
  // pour les sous-classes si les attributs sont privs
  public int getN() { return this.n;}
  public int[][] getTab() {return this.tab;}

}
